#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#

# Add entry in menu
# MENUENTRY copfilter 070 "C-ICAP Filter" "copfilter c-icap"

#
# Make sure translation exists $Lang::tr{'copfilter c-icap'}


use strict;
use IO::Socket;

# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################


################Variable 3rd rules
my $lastversion = `cat /var/log/copfilter/default/opt/privoxy/var/log/privoxy/LASTVERSION`;
my $privoxyver = system ('/bin/grep "*** Version 3.0.20" /var/log/copfilter/default/opt/privoxy/default/share/doc/privoxy/ChangeLog &>/dev/null 2>&1');
my $privoxymodA = system ('/bin/grep "configure_action_files" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');
my $privoxymodB = system ('/bin/grep "COMPLETE_RULES10" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');
my $privoxymodC = system ('/bin/grep "COMPLETE_RULES13" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');
my $privoxymodD = system ('/bin/grep "DNS_FILTERING" /var/log/copfilter/default/opt/privoxy/etc/init.d/copfilter_privoxy &>/dev/null 2>&1');


require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my %denysettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $status = '';
my $output = '';
my $OPTCOL = '';
my %upload = ();
my %uploadsettings = ();
my $Buffer = ();
my $line;
my @temp;

$uploadsettings{'ACTION'} = &Header::cleanhtml ($uploadsettings{'ACTION'});
$copfiltersettings{'ACTION'} = &Header::cleanhtml ($copfiltersettings{'ACTION'});
$copfiltersettings{'ACTION'} = '';

$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("/var/ipcop/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
$copfiltersettings{'ICAP_HOURS'} = sprintf("%02d", $copfiltersettings{'ICAP_HOURS'});
$copfiltersettings{'ICAP_MINUTES'} = sprintf("%02d", $copfiltersettings{'ICAP_MINUTES'});

sub read_domains
{
    my $blacklistdomains="${copfilter_swroot}/opt/c_icap/etc/denydomains.txt";
    my $whitelistdomains="${copfilter_swroot}/opt/c_icap/etc/allowdomains.txt";
    my $avscanexcept="${copfilter_swroot}/opt/c_icap/etc/avscanexceptions.txt";
    my $avscansource="${copfilter_swroot}/opt/c_icap/etc/avscansourceexceptions.txt";
    my $urlscanexcept="${copfilter_swroot}/opt/c_icap/etc/urlscanexceptions.txt";

    # read black- and whitelisted domains (source and destinations)
    unless ( -e $blacklistdomains ) { system("touch $blacklistdomains") };
    unless ( -e $whitelistdomains ) { system("touch $whitelistdomains") };
    unless ( -e $avscanexcept ) { system("touch $avscanexcept") };
    unless ( -e $avscansource ) { system("touch $avscansource") };
    unless ( -e $urlscanexcept ) { system("touch $urlscanexcept") };

    if ( -e $blacklistdomains ) {
        open(FILE, "<$blacklistdomains");
        delete $copfiltersettings{'ICAP_BLACK_DOMAINS'};
        while (<FILE>) { $copfiltersettings{'ICAP_BLACK_DOMAINS'} .= $_ };
        close(FILE);
    }

    if ( -e $whitelistdomains ) {
        open(FILE, "<$whitelistdomains");
        delete $copfiltersettings{'ICAP_WHITE_DOMAINS'};
        while (<FILE>) { $copfiltersettings{'ICAP_WHITE_DOMAINS'} .= $_ };
        close(FILE);
    }

    if ( -e $avscanexcept ) {
        open(FILE, "<$avscanexcept");
        delete $copfiltersettings{'ICAP_AVSCAN_EXCT'};
        while (<FILE>) { $copfiltersettings{'ICAP_AVSCAN_EXCT'} .= $_ };
        close(FILE);
    }

    if ( -e $avscansource ) {
        open(FILE, "<$avscansource");
        delete $copfiltersettings{'ICAP_AVSCAN_SRC'};
        while (<FILE>) { $copfiltersettings{'ICAP_AVSCAN_SRC'} .= $_ };
        close(FILE);
    }

    if ( -e $urlscanexcept ) {
        open(FILE, "<$urlscanexcept");
        delete $copfiltersettings{'ICAP_URL_EXCT'};
        while (<FILE>) { $copfiltersettings{'ICAP_URL_EXCT'} .= $_ };
        close(FILE);
    }
}

&read_domains;

#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
$uploadsettings{'ACTION'} = '';
my $upload_dir='/var/log/copfilter/default/opt/c_icap/tmp';
&General::getcgihash(\%uploadsettings, {'wantfile' => 1, 'filevar' => 'BL'});
&General::getcgihash(\%copfiltersettings);

if ($copfiltersettings{'ICAP_ENABLED'} eq '') { $copfiltersettings{'ICAP_ENABLED'} = 'off'; }
if ($copfiltersettings{'ICAP_AVSCAN_EXCEPT'} eq '') { $copfiltersettings{'ICAP_AVSCAN_EXCEPT'} = 'off'; }
if ($copfiltersettings{'ICAP_AVSCAN_SOURCE'} eq '') { $copfiltersettings{'ICAP_AVSCAN_SOURCE'} = 'off'; }
if ($copfiltersettings{'ICAP_USE_SOCKET'} eq '') { $copfiltersettings{'ICAP_USE_SOCKET'} = 'on'; }
if ($copfiltersettings{'ICAP_URL_EXCEPT'} eq '') { $copfiltersettings{'ICAP_URL_EXCEPT'} = 'off'; }
if ($copfiltersettings{'ICAP_UPDATE_METHOD'} !~ /^(manually|periodically)$/) { $copfiltersettings{'ICAP_UPDATE_METHOD'} = 'manually'; }
if ($copfiltersettings{'ICAP_UPDATE_PERIOD'} !~ /^(daily|weekly|monthly)$/) { $copfiltersettings{'ICAP_UPDATE_PERIOD'} = 'weekly'; }
if ($copfiltersettings{'ICAP_UPDATE_VALUE'} eq '') { $copfiltersettings{'ICAP_UPDATE_VALUE'} = '1'; }
if ($copfiltersettings{'ICAP_LIST_SOURCE'} eq '') { $copfiltersettings{'ICAP_LIST_SOURCE'} = 'shalla_blacklist'; }
if ($copfiltersettings{'ICAP_URLFILTER'} eq '') { $copfiltersettings{'ICAP_URLFILTER'} = 'off'; }
if ($copfiltersettings{'ICAP_AUDIO_ENABLED'} eq '') { $copfiltersettings{'ICAP_AUDIO_ENABLED'} = 'off'; }
if ($copfiltersettings{'ICAP_DENY_DOMAINS'} eq '') { $copfiltersettings{'ICAP_DENY_DOMAINS'} = 'off'; }
if ($copfiltersettings{'ICAP_ALLOW_DOMAINS'} eq '') { $copfiltersettings{'ICAP_ALLOW_DOMAINS'} = 'off'; }
if ($copfiltersettings{'ICAP_HOURS'} eq '') { $copfiltersettings{'ICAP_HOURS'} = '00'; }
if ($copfiltersettings{'ICAP_MINUTES'} eq '') { $copfiltersettings{'ICAP_MINUTES'} = '00'; }

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);

&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');

#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("/var/ipcop/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();










if ($copfiltersettings{'ICAP_PRIVOXY_ENABLE'} eq '') { $copfiltersettings{'ICAP_PRIVOXY_ENABLE'} = 'off'; }
if ($copfiltersettings{'HTTP_PRIVOXY_ENABLE'} eq '') { $copfiltersettings{'HTTP_PRIVOXY_ENABLE'} = 'off'; }

my $statusupdate = '';
my $CUR_VER = '';
my $CUR_MAIN = 0;
my $CUR_SUB1 = 0;
my $CUR_SUB2 = 0;
my $NEW_VER = '';
my $NEW_MAIN = 0;
my $NEW_SUB1 = 0;
my $NEW_SUB2 = 0;
my $UPDATE = 0;
my $THRDP = 0;


if ( system ("grep RULES_VERSION= ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
$THRDP = 1;
$CUR_VER = `echo $copfiltersettings{'RULES_VERSION'} | cut -d "b" -f1`;

if ( -e "${copfilter_swroot}/opt/privoxy/var/log/privoxy/LASTVERSION" ){
	$NEW_VER = `cat "${copfilter_swroot}/opt/privoxy/var/log/privoxy/LASTVERSION" | cut -d "b" -f1`;
}else{
	$NEW_VER = $CUR_VER;
}

$CUR_MAIN = `echo '$CUR_VER' | cut -d "." -f1`;
$CUR_SUB1 = `echo '$CUR_VER' | cut -d "." -f2`;
$CUR_SUB2 = `echo '$CUR_VER' | cut -d "." -f3`;

$NEW_MAIN = `echo '$NEW_VER' | cut -d "." -f1`;
$NEW_SUB1 = `echo '$NEW_VER' | cut -d "." -f2`;
$NEW_SUB2 = `echo '$NEW_VER' | cut -d "." -f3`;

if ( $NEW_MAIN eq $CUR_MAIN ){
	if ( $NEW_SUB1 eq $CUR_SUB1 ){
		if ( $NEW_SUB2 gt $CUR_SUB2 ){
			$UPDATE = 1;
		}
	}elsif ( $NEW_SUB1 gt $CUR_SUB1 ){
		$UPDATE = 1;
	}
}elsif ( $NEW_MAIN gt $CUR_MAIN ){
	$UPDATE = 1;
}
}else{
if ( system ("grep RULES_DISPLAY= ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
system('cat /var/log/copfilter/default/etc/global_settings | sed "s/^RULES_DISPLAY=.*$/RULES_DISPLAY=off/" > /tmp/global_settings');
system('chown nobody.nobody /tmp/global_settings');
system('mv -f /tmp/global_settings /var/log/copfilter/default/etc/global_settings');
}else{
system("echo 'RULES_DISPLAY=off' >> /var/log/copfilter/default/etc/global_settings");
}
}














################################################################################
##   C-ICAP
################################################################################

######### ICAP_HOURS
for(my $e = 0; $e <= 23; $e++)
{
    my $ee = sprintf("%02d", $e);
    $selected{'ICAP_HOUR'}{$ee} = '';
}
$selected{'ICAP_HOURS'}{$copfiltersettings{'ICAP_HOURS'}} = "selected='selected'";

######### ICAP_MINUTES
for(my $v = 0; $v <= 55; $v = $v + 5)
{
    my $vv = sprintf("%02d", $v);
    $selected{'ICAP_MINUTES'}{$vv} = '';
}
$selected{'ICAP_MINUTES'}{$copfiltersettings{'ICAP_MINUTES'}} = "selected='selected'";

######### PRIVOXY_ENABLE
$selected{'ICAP_PRIVOXY_ENABLE'}{'off'} = '';
$selected{'ICAP_PRIVOXY_ENABLE'}{'on'} = '';
$selected{'ICAP_PRIVOXY_ENABLE'}{$copfiltersettings{'ICAP_PRIVOXY_ENABLE'}} = "selected='selected'";
#

######## RULES  DISPLAY
$selected{'RULES_DISPLAY'}{'off'} = '';
$selected{'RULES_DISPLAY'}{'on'} = '';
$selected{'RULES_DISPLAY'}{$copfiltersettings{'RULES_DISPLAY'}} = "selected='selected'";
#
######## BASIC RULES ENABLE
$selected{'BASIC_RULES'}{'off'} = '';
$selected{'BASIC_RULES'}{'on'} = '';
$selected{'BASIC_RULES'}{$copfiltersettings{'BASIC_RULES'}} = "selected='selected'";
#
######## COMPLETE_RULES  ENABLE
$selected{'COMPLETE_RULES'}{'off'} = '';
$selected{'COMPLETE_RULES'}{'on'} = '';
$selected{'COMPLETE_RULES'}{$copfiltersettings{'COMPLETE_RULES'}} = "selected='selected'";
#
######## COMPLETE_RULES1  ENABLE
$selected{'COMPLETE_RULES1'}{'off'} = '';
$selected{'COMPLETE_RULES1'}{'on'} = '';
$selected{'COMPLETE_RULES1'}{$copfiltersettings{'COMPLETE_RULES1'}} = "selected='selected'";
#
######## COMPLETE_RULES2  ENABLE
$selected{'COMPLETE_RULES2'}{'off'} = '';
$selected{'COMPLETE_RULES2'}{'on'} = '';
$selected{'COMPLETE_RULES2'}{$copfiltersettings{'COMPLETE_RULES2'}} = "selected='selected'";
#
######## COMPLETE_RULES3  ENABLE
$selected{'COMPLETE_RULES3'}{'off'} = '';
$selected{'COMPLETE_RULES3'}{'on'} = '';
$selected{'COMPLETE_RULES3'}{$copfiltersettings{'COMPLETE_RULES3'}} = "selected='selected'";
#
######## COMPLETE_RULES4  ENABLE
$selected{'COMPLETE_RULES4'}{'off'} = '';
$selected{'COMPLETE_RULES4'}{'on'} = '';
$selected{'COMPLETE_RULES4'}{$copfiltersettings{'COMPLETE_RULES4'}} = "selected='selected'";
#
######## COMPLETE_RULES5  ENABLE
$selected{'COMPLETE_RULES5'}{'off'} = '';
$selected{'COMPLETE_RULES5'}{'on'} = '';
$selected{'COMPLETE_RULES5'}{$copfiltersettings{'COMPLETE_RULES5'}} = "selected='selected'";
#
######## COMPLETE_RULES6  ENABLE
$selected{'COMPLETE_RULES6'}{'off'} = '';
$selected{'COMPLETE_RULES6'}{'on'} = '';
$selected{'COMPLETE_RULES6'}{$copfiltersettings{'COMPLETE_RULES6'}} = "selected='selected'";
#
######## COMPLETE_RULES7  ENABLE
$selected{'COMPLETE_RULES7'}{'off'} = '';
$selected{'COMPLETE_RULES7'}{'on'} = '';
$selected{'COMPLETE_RULES7'}{$copfiltersettings{'COMPLETE_RULES7'}} = "selected='selected'";
#
######## COMPLETE_RULES8  ENABLE
$selected{'COMPLETE_RULES8'}{'off'} = '';
$selected{'COMPLETE_RULES8'}{'on'} = '';
$selected{'COMPLETE_RULES8'}{$copfiltersettings{'COMPLETE_RULES8'}} = "selected='selected'";
#
######## COMPLETE_RULES9  ENABLE
$selected{'COMPLETE_RULES9'}{'off'} = '';
$selected{'COMPLETE_RULES9'}{'on'} = '';
$selected{'COMPLETE_RULES9'}{$copfiltersettings{'COMPLETE_RULES9'}} = "selected='selected'";
#
######## COMPLETE_RULES10  ENABLE
$selected{'COMPLETE_RULES10'}{'off'} = '';
$selected{'COMPLETE_RULES10'}{'on'} = '';
$selected{'COMPLETE_RULES10'}{$copfiltersettings{'COMPLETE_RULES10'}} = "selected='selected'";
#
######## COMPLETE_RULES11  ENABLE
$selected{'COMPLETE_RULES11'}{'off'} = '';
$selected{'COMPLETE_RULES11'}{'on'} = '';
$selected{'COMPLETE_RULES11'}{$copfiltersettings{'COMPLETE_RULES11'}} = "selected='selected'";
#
######## COMPLETE_RULES12  ENABLE
$selected{'COMPLETE_RULES12'}{'off'} = '';
$selected{'COMPLETE_RULES12'}{'on'} = '';
$selected{'COMPLETE_RULES12'}{$copfiltersettings{'COMPLETE_RULES12'}} = "selected='selected'";
#
######## COMPLETE_RULES13  ENABLE
$selected{'COMPLETE_RULES13'}{'off'} = '';
$selected{'COMPLETE_RULES13'}{'on'} = '';
$selected{'COMPLETE_RULES13'}{$copfiltersettings{'COMPLETE_RULES13'}} = "selected='selected'";
#
######## COMPLETE_RULES14  ENABLE
$selected{'COMPLETE_RULES14'}{'off'} = '';
$selected{'COMPLETE_RULES14'}{'on'} = '';
$selected{'COMPLETE_RULES14'}{$copfiltersettings{'COMPLETE_RULES14'}} = "selected='selected'";
#
######## PRIVOXY_MAIL_NOTIF  ENABLE
$selected{'PRIVOXY_MAIL_NOTIF'}{'off'} = '';
$selected{'PRIVOXY_MAIL_NOTIF'}{'on'} = '';
$selected{'PRIVOXY_MAIL_NOTIF'}{$copfiltersettings{'PRIVOXY_MAIL_NOTIF'}} = "selected='selected'";
#
$selected{'PRIVOXY_UPDATE_METHOD'}{'manually'} = '';
$selected{'PRIVOXY_UPDATE_METHOD'}{'periodically'} = '';
$selected{'PRIVOXY_UPDATE_METHOD'}{$copfiltersettings{'PRIVOXY_UPDATE_METHOD'}} = "checked='checked'";
#
$selected{'PRIVOXY_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'daily'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'PRIVOXY_UPDATE_PERIOD'}{$copfiltersettings{'PRIVOXY_UPDATE_PERIOD'}} = "selected='selected'";
#
######## DNS FILTERING ENABLE
$selected{'DNS_FILTERING'}{'default'} = '';
$selected{'DNS_FILTERING'}{'Comodo SecureDNS'} = '';
$selected{'DNS_FILTERING'}{'Norton ConnectSafe 1'} = '';
$selected{'DNS_FILTERING'}{'Norton ConnectSafe 2'} = '';
$selected{'DNS_FILTERING'}{'OpenDNS'} = '';
$selected{'DNS_FILTERING'}{$copfiltersettings{'DNS_FILTERING'}} = "selected='selected'";
#
######### ICAP_ENABLED
$selected{'ICAP_ENABLED'}{'off'} = '';
$selected{'ICAP_ENABLED'}{'on'} = '';
$selected{'ICAP_ENABLED'}{$copfiltersettings{'ICAP_ENABLED'}} = "selected='selected'";

######### ICAP_VIRUS_SCAN
$selected{'ICAP_VIRUS_SCAN'}{'off'} = '';
$selected{'ICAP_VIRUS_SCAN'}{'on'} = '';
$selected{'ICAP_VIRUS_SCAN'}{$copfiltersettings{'ICAP_VIRUS_SCAN'}} = "selected='selected'";

########## ICAP_VIRUS_SCAN Options
$selected{'ICAP_AVSCAN_EXCEPT'}{'off'} = '';
$selected{'ICAP_AVSCAN_EXCEPT'}{'on'} = '';
$selected{'ICAP_AVSCAN_EXCEPT'}{$copfiltersettings{'ICAP_AVSCAN_EXCEPT'}} = "selected='selected'";
$selected{'ICAP_AVSCAN_SOURCE'}{'off'} = '';
$selected{'ICAP_AVSCAN_SOURCE'}{'on'} = '';
$selected{'ICAP_AVSCAN_SOURCE'}{$copfiltersettings{'ICAP_AVSCAN_SOURCE'}} = "selected='selected'";

######### ICAP_VIRUS_SCAN_TRANSPARENT
$selected{'ICAP_VIRUS_SCAN_TRANSPARENT'}{'off'} = '';
$selected{'ICAP_VIRUS_SCAN_TRANSPARENT'}{'on'} = '';
$selected{'ICAP_VIRUS_SCAN_TRANSPARENT'}{$copfiltersettings{'ICAP_VIRUS_SCAN_TRANSPARENT'}} = "selected='selected'";

######### ICAP_VIRUS_USE_SOCKET
$selected{'ICAP_USE_SOCKET'}{'off'} = '';
$selected{'ICAP_USE_SOCKET'}{'on'} = '';
$selected{'ICAP_USE_SOCKET'}{$copfiltersettings{'ICAP_USE_SOCKET'}} = "selected='selected'";

######### ICAP_AUDIO_ENABLED
$selected{'ICAP_AUDIO_ENABLED'}{'off'} = '';
$selected{'ICAP_AUDIO_ENABLED'}{'on'} = '';
$selected{'ICAP_AUDIO_ENABLED'}{$copfiltersettings{'ICAP_AUDIO_ENABLED'}} = "selected='selected'";

########## ICAP_URLFILTER Options
$selected{'ICAP_BLACKLIST'}{'off'} = '';
$selected{'ICAP_BLACKLIST'}{'on'} = '';
$selected{'ICAP_BLACKLIST'}{$copfiltersettings{'ICAP_BLACKLIST'}} = "selected='selected'";
$selected{'ICAP_DENY_DOMAINS'}{'off'} = '';
$selected{'ICAP_DENY_DOMAINS'}{'on'} = '';
$selected{'ICAP_DENY_DOMAINS'}{$copfiltersettings{'ICAP_DENY_DOMAINS'}} = "selected='selected'";
$selected{'ICAP_ALLOW_DOMAINS'}{'off'} = '';
$selected{'ICAP_ALLOW_DOMAINS'}{'on'} = '';
$selected{'ICAP_ALLOW_DOMAINS'}{$copfiltersettings{'ICAP_ALLOW_DOMAINS'}} = "selected='selected'";
$selected{'ICAP_DNSBL'}{'off'} = '';
$selected{'ICAP_DNSBL'}{'on'} = '';
$selected{'ICAP_DNSBL'}{$copfiltersettings{'ICAP_DNSBL'}} = "selected='selected'";
$selected{'ICAP_URLFILTER'}{'off'} = '';
$selected{'ICAP_URLFILTER'}{'on'} = '';
$selected{'ICAP_URLFILTER'}{$copfiltersettings{'ICAP_URLFILTER'}} = "selected='selected'";
$selected{'ICAP_URL_EXCEPT'}{'off'} = '';
$selected{'ICAP_URL_EXCEPT'}{'on'} = '';
$selected{'ICAP_URL_EXCEPT'}{$copfiltersettings{'ICAP_URL_EXCEPT'}} = "selected='selected'";
$selected{'ICAP_SENDMAIL'}{'off'} = '';
$selected{'ICAP_SENDMAIL'}{'on'} = '';
$selected{'ICAP_SENDMAIL'}{$copfiltersettings{'ICAP_SENDMAIL'}} = "selected='selected'";



########## ICAP UPDATE INTERVALL
$selected{'ICAP_UPDATE_METHOD'}{'manually'} = '';
$selected{'ICAP_UPDATE_METHOD'}{'periodically'} = '';
$selected{'ICAP_UPDATE_METHOD'}{$copfiltersettings{'ICAP_UPDATE_METHOD'}} = "checked='checked'";

$selected{'ICAP_UPDATE_PERIOD'}{'daily'} = '';
$selected{'ICAP_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'ICAP_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'ICAP_UPDATE_PERIOD'}{$copfiltersettings{'ICAP_UPDATE_PERIOD'}} = "selected='selected'";

$selected{'ICAP_LIST_SOURCE'}{'shalla_blacklist'} = '';
$selected{'ICAP_LIST_SOURCE'}{'url_blacklist_big'} = '';
$selected{'ICAP_LIST_SOURCE'}{'url_blacklist_small'} = '';
$selected{'ICAP_LIST_SOURCE'}{'university_toulouse'} = '';
$selected{'ICAP_LIST_SOURCE'}{'mesd'} = '';
$selected{'ICAP_LIST_SOURCE'}{'manual_upload'} = '';
$selected{'ICAP_LIST_SOURCE'}{$copfiltersettings{'ICAP_LIST_SOURCE'}} = "selected='selected'";


########## ICAP automatic generated BLACKLIST OPTIONS
my $z = 0;
my $b = 0;
my @BLACK = ();
my $COUNT = 0;
my %BLACK = ();
my $BASEDIR = "/var/log/copfilter/default";
my @BLACK = `cat $BASEDIR/etc/global_settings | grep 'ICAP_BL' | sed 's/=on//g' | sed 's/=off//g'`;
my @COUNT=<@BLACK>;
my $COUNT=int(@COUNT);
my $q;
for ($b = 0; $b <= $COUNT; $b++) {
    $BLACK[$b] =~ s/\s//g;
    $q=$BLACK[$b];
    $selected{$q}{'off'} = '';
    $selected{$q}{'on'} = '';
    $selected{$q}{$copfiltersettings{$q}} = "selected='selected'";
}

my @BLACKNAME = ();
@BLACKNAME = `cat $BASEDIR/etc/global_settings | grep 'ICAP_BL' | sed 's/ICAP_BL_//g' | sed 's/=on//g' | sed 's/=off//g'`;



################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_c-icap.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);

        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;

        foreach $var (sort (keys %$hash))
        {
            $val = $hash->{$var};
            # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
            # location of the mouse are submitted as well, this was being written to the settings file causing
            # some serious grief! This skips the variable.x and variable.y
            if (!($var =~ /^ICAP_WHITE_DOMAINS$/) && !($var =~ /^ICAP_BLACK_DOMAINS$/) && !($var =~ /^ICAP_AVSCAN_EXCT$/) && !($var =~ /^ICAP_AVSCAN_SRC$/) && !($var =~ /^ICAP_URL_EXCT$/) ) {
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                $var =~ s/\s//g;
                                print FILE "${var}=${val}\n"; }
                }
            }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}


sub check_domaininput
{
    @temp = split(/\n/,$copfiltersettings{'ICAP_BLACK_DOMAINS'});
    undef $copfiltersettings{'ICAP_BLACK_DOMAINS'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'ICAP_BLACK_DOMAINS'} .= $line."\n";
        }
    }

    @temp = split(/\n/,$copfiltersettings{'ICAP_WHITE_DOMAINS'});
    undef $copfiltersettings{'ICAP_WHITE_DOMAINS'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'ICAP_WHITE_DOMAINS'} .= $line."\n";
        }
    }
}

sub write_domains
{
        my $blacklistdomains="${copfilter_swroot}/opt/c_icap/etc/denydomains.txt";
        my $whitelistdomains="${copfilter_swroot}/opt/c_icap/etc/allowdomains.txt";
        &check_domaininput;
        open(FILE, ">$blacklistdomains");
        flock(FILE, 2);
        print FILE $copfiltersettings{'ICAP_BLACK_DOMAINS'};
        close(FILE);

        open(FILE, ">$whitelistdomains");
        flock(FILE, 2);
        print FILE $copfiltersettings{'ICAP_WHITE_DOMAINS'};
        close(FILE);
}

sub check_avinput
{
    @temp = split(/\n/,$copfiltersettings{'ICAP_AVSCAN_EXCT'});
    undef $copfiltersettings{'ICAP_AVSCAN_EXCT'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'ICAP_AVSCAN_EXCT'} .= $line."\n";
        }
    }

    @temp = split(/\n/,$copfiltersettings{'ICAP_AVSCAN_SRC'});
    undef $copfiltersettings{'ICAP_AVSCAN_SRC'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'ICAP_AVSCAN_SRC'} .= $line."\n";
        }
    }
}

sub write_avinput
{
        my $avscanexcept="${copfilter_swroot}/opt/c_icap/etc/avscanexceptions.txt";
        my $avscansource="${copfilter_swroot}/opt/c_icap/etc/avscansourceexceptions.txt";
        &check_avinput;
        open(FILE, ">$avscanexcept");
        flock(FILE, 2);
        print FILE $copfiltersettings{'ICAP_AVSCAN_EXCT'};
        close(FILE);

        open(FILE, ">$avscansource");
        flock(FILE, 2);
        print FILE $copfiltersettings{'ICAP_AVSCAN_SRC'};
        close(FILE);
}

sub check_urlinput
{
    @temp = split(/\n/,$copfiltersettings{'ICAP_URL_EXCT'});
    undef $copfiltersettings{'ICAP_URL_EXCT'};
    foreach (@temp)
    {
        s/^\s+//g; s/\s+$//g;
        if ($_)
        {
            $line = $_;
            $line =~ /[a-zA-Z0-9][a-zA-Z0-9_.-]*/;
            $copfiltersettings{'ICAP_URL_EXCT'} .= $line."\n";
        }
    }
}

sub write_urlinput
{
        my $urlscanexcept="${copfilter_swroot}/opt/c_icap/etc/urlscanexceptions.txt";
        &check_urlinput;
        open(FILE, ">$urlscanexcept");
        flock(FILE, 2);
        print FILE $copfiltersettings{'ICAP_URL_EXCT'};
        close(FILE);
}



################################################################################
##   ACTIONs
################################################################################



######### Update Privoxy Rules
if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter privoxy update now'})
{
     	 system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_privoxy.done");
        system ('/usr/bin/touch', "/tmp/copfilter_check-updates_privoxy.done");
        $copfiltersettings{'ACTION'} = '';
}




######### Reload C-ICAP

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter c-icap_reload'}) {
    $status = `ls $BASEDIR/opt/c_icap/var/run | grep 'copfilter_c-icap-dbmaker.pid'`;
    if ( $status ) {
        &copfilter_start_log();
        print "<table width='100%'><td class='base' align='center'><hr style='color:black; background: black; height:2px; width:60%;'>";
        print "<br /><font color='#D61010'><b>The C-ICAP URL-Filter DBmaker is still running! Please do not restart or reload C-ICAP!</b></font><br /><br />";
        print "<hr style='color:black; background: black; height:2px; width:60%;'></td></table>";
        &copfilter_stop_log();
        exit 0;
    } else {
        &write_domains;
        &write_avinput;
        &write_urlinput;
        &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
        &copfilter_start_log();
        print "<br /><b>$Lang::tr{'copfilter c-icap_reload'} c-icap ...</b> <br />";
        system('/usr/local/bin/copfilter_reloadc-icap');
        &copfilter_stop_log();
        exit 0;
    }
}

########## Download Blacklist

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter c-icap_update_blacklist_now'}) {
    &write_domains;
    &write_avinput;
    &write_urlinput;
    &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
    &copfilter_start_log();
    print "<br /><b>$Lang::tr{'copfilter c-icap_blacklist_download_convert'} ...</b> <br />";
    system("/usr/local/bin/copfilter_urlfilter-download");
    &copfilter_stop_log();
    exit 0;
}


######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{
################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'IMSPECTOR_PROXY_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMSPECTOR_PROXY_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMSPECTOR_PROXY_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'ICAP_PRIVOXY_ENABLE'} !~ /^(on|off)$/ ||
#########################################3rdp rules #################################
	    $copfiltersettings{'RULES_DISPLAY'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'BASIC_RULES'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'COMPLETE_RULES'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES1'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES2'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES3'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES4'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES5'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES6'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES7'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES8'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES9'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES10'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES11'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES12'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES13'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'COMPLETE_RULES14'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'PRIVOXY_MAIL_NOTIF'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'DNS_FILTERING'} !~ /^(default|Comodo SecureDNS|Norton ConnectSafe 1|Norton ConnectSafe 2|OpenDNS)$/ ||
	    $copfiltersettings{'ICAP_SENDMAIL'} !~ /^(on|off)$/ ||

###########################################################################
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_CLAMAV'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_CLAMAV_LIBRARY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HAVP_TMPFS'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN_FPROT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ )
	    
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

        if ( $copfiltersettings{'ICAP_PRIVOXY_ENABLE'} eq 'on' && $copfiltersettings{'ICAP_ENABLED'} eq 'off')
        {
                $errormessage = $Lang::tr{'copfilter enable havp'};
                goto ERROR;
        }



	if (!($copfiltersettings{'PRIVOXY_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid privoxy time period'};
                goto ERROR;
        }


ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }


################################################################################
##   set update values
################################################################################


        # C-ICAP Urlfilter intervall

        # set some values for calculating blacklist update time
        my $MIN = `date +%M`;
        my $HOR = `date +%H`;
        my $EXACT = ( $HOR * 60 ) + $MIN;
        my $REALM = ();
        $REALM = int($EXACT/5)*5;
        my $SMIN = ();
        $SMIN = ( ($copfiltersettings{'ICAP_HOURS'} * 60) + ($copfiltersettings{'ICAP_MINUTES'}) );
        my ($icap_updateperiod)=();
        my ($icap_realtime)=();

        # calculate normal update intervall
        if  ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'daily') {
                $icap_updateperiod = $copfiltersettings{'ICAP_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'weekly') {
                $icap_updateperiod = $copfiltersettings{'ICAP_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'monthly') {
                $icap_updateperiod = $copfiltersettings{'ICAP_UPDATE_VALUE'} * 40320; }
        else {
                $icap_updateperiod = $copfiltersettings{'ICAP_UPDATE_VALUE'} * 1440; }

        # Calculate first time to run blacklist update
        if  ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'daily') {
            if ($SMIN <= $REALM) {
                $icap_realtime = ( ( ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 1440 ) - $REALM ) + $SMIN ) ;
            } else {
                if ( $copfiltersettings{'ICAP_UPDATE_VALUE'} == 1 ) {
                    $icap_realtime = ( $SMIN - $REALM );
                } else {
                    $icap_realtime = ( ( $SMIN - $REALM ) + ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 1440 ) );
                }
            }
        }
        elsif  ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'weekly') {
            if ($SMIN <= $REALM) {
                $icap_realtime = ( ( ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 10080 ) - $REALM ) + $SMIN );
            } else {
                $icap_realtime = ( ( $SMIN - $REALM ) + ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 10080 ) );
            }
        }
        elsif  ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'monthly') {
            if ($SMIN <= $REALM) {
                $icap_realtime = ( ( ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 40320 ) - $REALM ) + $SMIN );
            } else {
                $icap_realtime = ( ( $SMIN - $REALM ) + ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 40320 ) );
            }
        }
        elsif ($SMIN <= $REALM) {
                $icap_realtime = ( ( ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 1440 ) - $REALM ) + $SMIN ) ;
        } else {
            if ( $copfiltersettings{'ICAP_UPDATE_VALUE'} = 1 ) {
                $icap_realtime = ( $SMIN - $REALM );
            } else {
                $icap_realtime = ( ( $SMIN - $REALM ) + ( $copfiltersettings{'ICAP_UPDATE_VALUE'} * 1440 ) );
            }
        }


        $icap_updateperiod = $icap_updateperiod - 5;
        $icap_realtime = $icap_realtime - 5;

        if ($icap_updateperiod <= 5) { $icap_updateperiod = 5; }

        open(FILE, "</${copfilter_swroot}/etc/icap_counter.conf");
        my $COUNTER =<FILE> ;
        close(FILE);

        open(FILE, ">/${copfilter_swroot}/etc/icap_counter.conf") or die;
        flock(FILE, 2);
        print FILE "$icap_updateperiod\n";
        close FILE;

        if ($copfiltersettings{'ICAP_UPDATE_METHOD'} eq 'periodically')
        {
            if ( ! -e "${copfilter_swroot}/etc/icap_counter") {
                system("touch ${copfilter_swroot}/etc/icap_counter");
                system("chown nobody.nobody ${copfilter_swroot}/etc/icap_counter");
            }

            # check, if we are up to date
            if ( $COUNTER ne $icap_updateperiod || $copfiltersettings{'ICAP_UPDATE_VALUE'} == 1 && ($copfiltersettings{'ICAP_UPDATE_PERIOD'} eq 'daily') ) {
                open(FILE, ">/${copfilter_swroot}/etc/icap_counter") or die "Unable to write icap_counter file";
                flock(FILE, 2);
                print FILE "$icap_realtime\n";
                close FILE;
            }
        }




        # PRIVOXY
        my ($privoxy_updateperiod)=();

        if  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'hourly') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'daily') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'weekly') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'PRIVOXY_UPDATE_PERIOD'} eq 'monthly') {
        	$privoxy_updateperiod = $copfiltersettings{'PRIVOXY_UPDATE_VALUE'} * 40320; }
        

        $privoxy_updateperiod = $privoxy_updateperiod - 5;

        if ($privoxy_updateperiod <= 5) {
        	$privoxy_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/privoxy_counter.conf") or die $Lang::tr{'copfilter privoxy_counter'};
        flock(FILE, 2);
        print FILE "$privoxy_updateperiod\n";
        close FILE;





################################################################################
##   purge enable and update files
################################################################################


	if ($copfiltersettings{'VALID'} eq 'yes')
        {

	    unlink "${copfilter_swroot}/etc/c-icap_enable";
	    if ( $copfiltersettings{'HTTP_PRIVOXY_ENABLE'} eq 'off' ) {
	    unlink "${copfilter_swroot}/etc/http_privoxy_enable";

	# MODIFIKATION BEGIN
	unlink "${copfilter_swroot}/etc/privoxy_enable"; 
	}
	# MODIFIKATION END

	    unlink "${copfilter_swroot}/etc/icap_privoxy_enable";

        if ( $copfiltersettings{'ICAP_ENABLED'} eq 'on' ) {
		    system ('/usr/bin/touch', "${copfilter_swroot}/etc/c-icap_enable"); }
	if (($copfiltersettings{'ICAP_PRIVOXY_ENABLE'} eq 'on') && ($copfiltersettings{'ICAP_VIRUS_SCAN'}) eq 'on' || ($copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'on' )) {
	    system ('/usr/bin/touch', "${copfilter_swroot}/etc/icap_privoxy_enable");

	# MODIFIKATION BEGIN
	system ('/usr/bin/touch', "${copfilter_swroot}/etc/privoxy_enable"); 
	}
	# MODIFIKATION END




	if ( ! -e "${copfilter_swroot}/etc/privoxy_counter") {
                if ($copfiltersettings{'PRIVOXY_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/privoxy_counter") or die "Unable to write privoxy_counter file";
                        flock(FILE, 2);
                        print FILE "$privoxy_updateperiod\n";
                        close FILE;
                }
           }



# if setting were valid, write settings and reconfigure

        # check, if we are allowed for privoxy
        &write_domains;
        &write_avinput;
        &write_urlinput;
        &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);

        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on') && ! ($uploadsettings{'SKIP_RESTART'} eq 'on')) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} c-icap..</b> <br />";
            system('/usr/local/bin/copfilter_restartc-icap');
            print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";

            system('/usr/local/bin/copfilter_restartprivoxy');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log();
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }
}

if ($uploadsettings{'ACTION'} eq $Lang::tr{'copfilter c-icap_upload_blacklist'}) {
    my $upload;
    my %upload;
    $copfiltersettings{'ICAP_LIST_SOURCE'} = "manual_upload";
    &write_domains;
    &write_avinput;
    &write_urlinput;
    &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
    copfilter_start_log
    &General::log("c-icap blacklist upload", "Uploaded update file: $uploadsettings{'BL'}");
    open (OUTPUT, ">$upload_dir/$uploadsettings{'BL'}");
    undef $Buffer;
    while (read($uploadsettings{'BL'},$Buffer,1024000)) {
    print OUTPUT $Buffer;
    }
    close(OUTPUT);
    print "<font class='base'><b>$Lang::tr{'copfilter patient'} ...</b><br /><br /></font>\n";
    system("/usr/local/bin/copfilter_urlfilter-icap");
    print "<br />";
    # print "<font class='base'><b>$Lang::tr{'copfilter c-icap_converter_finished_notice'}</b><br /><br /></font>\n";
    &copfilter_stop_log();
    exit 0;
}


################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    #print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}

#if  ( ($copfiltersettings{'HTTP_VIRUS_SCAN'} eq 'on' )) {
#    &Header::openbox('100%', 'left', $Lang::tr{'copfilter c-icap important'});
#    #print "<font color='C01327'class='base'><b>C-ICAP is not usable, until HAVP is been deactivatet!&nbsp;</b></font>\n";
#    print "<font color='C01327'class='base'><b>$Lang::tr{'copfilter c-icap warning'}&nbsp;</b></font>\n";
#    &Header::closebox();
#}

# check, if squid has benn replaced, for supporting icap protocol
my $SQUIDVER=`/usr/sbin/squid -v | grep icap`;
if ( "x$SQUIDVER" eq "x" ) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter c-icap important'});
    print "<font color='C01327'class='base'><h1>$Lang::tr{'copfilter c-icap notusable'}&nbsp;</h1></font>\n";
    print "$Lang::tr{'copfilter c-icap notusable notice'}&nbsp;\n";
    &Header::closebox();
&Header::closebigbox();

&Header::closepage();
exit;
}

################################################################################
##  Website - C-ICAP Scanning
################################################################################

my $output = `/etc/rc.d/init.d/copfilter_c-icap pid weboutput`;
my $status = '';
if ( $output =~ /OFF/ ) { $status="<td width='180' height='10' bgcolor='#C01327' align='center' ><font color='#FFFFFF'size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td width='180' height='10' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $output =~ /ON/ ) { $status="<td width='180' height='10' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

my $outputprivoxy = `/etc/rc.d/init.d/copfilter_privoxy pid weboutput`;
if ( $outputprivoxy =~ /ON/ ) {
	if ($copfiltersettings{'ICAP_PRIVOXY_ENABLE'} eq 'off' ) {
	$outputprivoxy = 'NOT ACTIVATED HAVP';
	}
}
elsif ( $outputprivoxy =~ /OFF/ ) {
	if ($copfiltersettings{'ICAP_PRIVOXY_ENABLE'} eq 'off' ) {
	$outputprivoxy = 'NOT ACTIVATED';
	}
}	
my $statusprivoxy = '';
if ( $outputprivoxy =~ /OFF/ ) { $statusprivoxy="<td width='200' height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $outputprivoxy =~ /NOT ACTIVATED/ ) { $statusprivoxy="<td width='200' height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $outputprivoxy =~ /NOT ACTIVATED HAVP/ ) { $statusprivoxy="<td width='200' height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> RUNNING WITH HAVP <\/b><\/font>";; }
if ( $outputprivoxy =~ /ON/ ) { $statusprivoxy="<td width='200' height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }


my $outputdns = `cat /var/log/copfilter/default/opt/dns/dns`;
my $statusdns = "";
if ( $outputdns =~ /default/ ) { $statusdns="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $outputdns =~ /SecureDNS/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }
if ( $outputdns =~ /NORTON1/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }
if ( $outputdns =~ /NORTON2/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }
if ( $outputdns =~ /OPENDNS/ ) { $statusdns="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }



print "<a name='http'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter c-icap'}:");
print "<form method='post' action='/cgi-bin/copfilter_c-icap.cgi' enctype='multipart/form-data'>";

my $PRIVMSG = '';
if ( $copfiltersettings{'ICAP_VIRUS_SCAN'} eq 'off' ) {
#    $PRIVMSG="<a><br /><br /><b>Privoxy not usable</b></a>";
    } else {
    $PRIVMSG = '';
    }



print <<END

<table border='0' cellpadding='5'>

<tr>
    <td width='150' colspan='1'><font size='2.7em'><b>C-ICAP Status:</b></td>
    $status
   <td colspan='2'></td>
</tr>

</table>
END
;

    if ($copfiltersettings{'ICAP_ENABLED'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END

<table border='0' cellpadding='5'>

<tr>
	<td width='11%'></td>
	<td width='14%'></td>
	<td width='3%'></td>
	<td width='13%'></td>
	<td width='5%'></td>
	<td width='19%'></td>
	<td width='10%'></td>
	<td width='3%'></td>
	<td width='3%'></td>
	<td width='19%'></td>
</tr>




<!-- $Lang::tr{'copfilter http_web_proxy_enable'} -->

<tr>
        <td colspan='2'> $Lang::tr{'copfilter c-icap_enable'} </td>
        <td> <select name='ICAP_ENABLED' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_ENABLED'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_ENABLED'}{'off'}>off</option> </select></td>

</tr>
END
;

if ($copfiltersettings{'ICAP_VIRUS_SCAN'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END

<tr>
       <td colspan='2'>  $Lang::tr{'copfilter c-icap_virscan'}</td>
        <td> <select name='ICAP_VIRUS_SCAN' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_VIRUS_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_VIRUS_SCAN'}{'off'}>off</option> </select></td>
	<td> &nbsp;</td>

END
;

if ($copfiltersettings{'ICAP_VIRUS_SCAN_TRANSPARENT'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
        <td colspan='2'> $Lang::tr{'copfilter c-icap_virscan_transparent'}</td>
        <td> <select name='ICAP_VIRUS_SCAN_TRANSPARENT' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_VIRUS_SCAN_TRANSPARENT'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_VIRUS_SCAN_TRANSPARENT'}{'off'}>off</option> </select></td>

</tr>
	
END
;


if ($copfiltersettings{'ICAP_USE_SOCKET'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
        <td colspan='2'>  $Lang::tr{'copfilter c-icap_use_socket'}</td>
        <td> <select name='ICAP_USE_SOCKET' style="border:2px solid $OPTCOL;">
              <option value='on' $selected{'ICAP_USE_SOCKET'}{'on'}>on</option>
              <option value='off' $selected{'ICAP_USE_SOCKET'}{'off'}>off</option> </select></td>

END
;

if ($copfiltersettings{'ICAP_AUDIO_ENABLED'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END

<td> &nbsp;</td>

        <td colspan='2'> $Lang::tr{'copfilter c-icap_virscan_audio'}</td>
        <td> <select name='ICAP_AUDIO_ENABLED' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_AUDIO_ENABLED'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_AUDIO_ENABLED'}{'off'}>off</option> </select></td>
</tr>

</table>
END
;

if ($copfiltersettings{'ICAP_AVSCAN_EXCEPT'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
<tr>
	<td> &nbsp;</td>
</tr>

<!--- AV-Scan Exceptions --->

<table border='0' cellpadding='5'>

<tr>
	<td width='11%'></td>
	<td width='14%'></td>
	<td width='3%'></td>
	<td width='13%'></td>
	<td width='5%'></td>
	<td width='19%'></td>
	<td width='10%'></td>
	<td width='3%'></td>
	<td width='3%'></td>
	<td width='19%'></td>
</tr>

<tr>
        <td colspan='2'> $Lang::tr{'copfilter c-icap_virus_exceptions'}</td>
        <td> <select name='ICAP_AVSCAN_EXCEPT' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_AVSCAN_EXCEPT'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_AVSCAN_EXCEPT'}{'off'}>off</option> </select></td>

END
;

if ($copfiltersettings{'ICAP_AVSCAN_SOURCE'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<td> &nbsp;</td>
        <td colspan='2'> $Lang::tr{'copfilter c-icap_virus_exceptions_src'}</td>
        <td> <select name='ICAP_AVSCAN_SOURCE' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_AVSCAN_SOURCE'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_AVSCAN_SOURCE'}{'off'}>off</option> </select></td>
        <td>\n</td>
</tr>
</table>
<table border='0' cellpadding='5'>

<tr>
	<td width='11%'></td>
	<td width='14%'></td>
	<td width='3%'></td>
	<td width='15%'></td>
	<td width='3%'></td>
	<td width='19%'></td>
	<td width='10%'></td>
	<td width='3%'></td>
	<td width='3%'></td>
	<td width='19%'></td>
</tr>
<tr>
        <td colspan='2'><textarea name='ICAP_AVSCAN_EXCT' cols='35' rows='8' />
END
;
        print $copfiltersettings{'ICAP_AVSCAN_EXCT'};
print <<END

</textarea></td>

<td> &nbsp;</td>
<td> &nbsp;</td>
        <td colspan='2'><textarea name='ICAP_AVSCAN_SRC' cols='35' rows='8' />
END
;
        print $copfiltersettings{'ICAP_AVSCAN_SRC'};
print <<END
</textarea></td>
        <td>\n</td>


<tr>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
</tr>

</table>


END
;



print <<END

<table border='0' cellpadding='5'>

<tr>
    <td width='150' colspan='0'><font size='2.7em'><b>Privoxy Status:</b></td>
    $statusprivoxy
    <td width='50 colspan='2'>&nbsp;</td>

</tr>
</table>

<table border='0' cellpadding='5'>

<tr>
	<td width='11%'></td>
	<td width='14%'></td>
	<td width='3%'></td>
	<td width='20'></td>
	<td width='5%'></td>
	<td width='10%'></td>
	<td width='15%'></td>
	<td width='3%'></td>
	<td width='3%'></td>
	<td width='18%'></td>
</tr>

<tr>

         <td colspan='10'> $Lang::tr{'copfilter http2'}</td>

</tr>

END
;

print <<END

<tr>
             <td colspan='2'><a href='http://config.privoxy.org' [^] target=_blank><u>privoxy configuration</u></a></td>

              <td colspan='2'><a href="javascript:void(window.open('http://config.privoxy.org/toggle?mini=y&amp;set=toggle','ijbstatus','height=100,resizable=yes,scrollbars=no,toolbar=no,location=no,directories=no,status=no,menubar=no,copyhistory=no').focus());"> <u>privoxy bookmarklet</u></a></td>
</tr>
<tr>
	<td>&nbsp;</td>
</tr>

END
;

if ( $copfiltersettings{'ICAP_PRIVOXY_ENABLE'} !~/^off$/) {
     $OPTCOL='#009C28'; }
else {
     $OPTCOL='#C1C1C1'; }

print <<END

<tr>

        <td colspan='2'> $Lang::tr{'copfilter http_scan'} </td>
	<td> <select name='ICAP_PRIVOXY_ENABLE' style="border:2px solid $OPTCOL;">

             <option value='on' $selected{'ICAP_PRIVOXY_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_PRIVOXY_ENABLE'}{'off'}>off</option> </select></td>


END
;



if ($copfiltersettings{'RULES_DISPLAY'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


if ( $UPDATE eq 1 ) {
$statusupdate="<font color='#C01327'><b> $Lang::tr{'copfilter clamd thrdp_info11'} VERSION $NEW_VER $Lang::tr{'copfilter clamd thrdp_info12'} </b></font>"; }
else { $statusupdate='';}



print <<END
<td> &nbsp;</td>
<td> &nbsp;</td>

	<td colspan='2'> $Lang::tr{'copfilter clamd thrdp_gui'} </td>
	<td> <select name='RULES_DISPLAY' style="border:2px solid $OPTCOL;">

	<option value='on' $selected{'RULES_DISPLAY'}{'on'}>on</option>
       <option value='off' $selected{'RULES_DISPLAY'}{'off'}>off</option> </select></td>
	<td colspan='2' nowrap> <b>$Lang::tr{'copfilter privoxy rules_info'} $copfiltersettings{'RULES_VERSION'}<br>$statusupdate</b></td>

</tr>	
	
END
;


############# file date info##################
my $banner = '';
my $malware = '';
my $fandat = '';
my $adbdat = '';
my $plowdat = '';
my $elistdat = '';
my $eprivdat = '';
my $egerdat = '';
my $efrdat = '';
my $eitdat = '';
my $mdomdat = '';
my $hphdat = '';
my $mdomlistdat = '';
my $mcodedat = '';
my $mopbldat = '';
my $adverdat = '';
my $antisodat = '';

#fanboy version
if ($copfiltersettings{'COMPLETE_RULES'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/fanboy.script.action" ){ 
$fandat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep fanboy.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$fandat = &Header::cleanhtml($fandat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#fanboy social version
if ($copfiltersettings{'COMPLETE_RULES1'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/fanboysocial.script.action" ){ 
$adbdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep fanboysocial.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$adbdat = &Header::cleanhtml($adbdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#peter lowe version
if ($copfiltersettings{'COMPLETE_RULES3'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/peter_lowe.script.action" ){ 
$plowdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep peter_lowe.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$plowdat = &Header::cleanhtml($plowdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

if ( $privoxymodB eq 0 && $privoxyver eq 0 ){
#easy list version
if ($copfiltersettings{'COMPLETE_RULES6'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylist.script.action" ){ 
$elistdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylist.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$elistdat = &Header::cleanhtml($elistdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy privacy version
if ($copfiltersettings{'COMPLETE_RULES7'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easyprivacy.script.action" ){ 
$eprivdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easyprivacy.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$eprivdat = &Header::cleanhtml($eprivdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy ge version
if ($copfiltersettings{'COMPLETE_RULES8'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylistgermany.script.action" ){ 
$egerdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylistgermany.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$egerdat = &Header::cleanhtml($egerdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy fr version
if ($copfiltersettings{'COMPLETE_RULES9'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylistFR.script.action" ){ 
$efrdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylistFR.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$efrdat = &Header::cleanhtml($efrdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#easy it version
if ($copfiltersettings{'COMPLETE_RULES11'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/easylistIT.script.action" ){ 
$eitdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep easylistIT.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$eitdat = &Header::cleanhtml($eitdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}}} 


if ( $privoxymodC eq 0 && $privoxyver eq 0 ){
#Adversity list version
if ($copfiltersettings{'COMPLETE_RULES13'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/Adversity.script.action" ){ 
$adverdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep Adversity.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$adverdat = &Header::cleanhtml($adverdat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}} 

#Antisocial version
if ($copfiltersettings{'COMPLETE_RULES14'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/Antisocial.script.action" ){ 
$antisodat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep Antisocial.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$antisodat = &Header::cleanhtml($antisodat,"y"); 
$banner = "$Lang::tr{'copfilter privoxy rules_info2'}:";
}}} 



#maldomain version
if ($copfiltersettings{'COMPLETE_RULES2'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/malwaredomains.script.action" ){ 
$mdomdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep malwaredomains.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mdomdat = &Header::cleanhtml($mdomdat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

#hphost version
if ($copfiltersettings{'COMPLETE_RULES4'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/HpHosts.script.action" ){ 
$hphdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep HpHosts.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$hphdat = &Header::cleanhtml($hphdat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

#maldomain list version
if ($copfiltersettings{'COMPLETE_RULES5'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/malwaredomainlist.script.action" ){ 
$mdomlistdat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep malwaredomainlist.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mdomlistdat = &Header::cleanhtml($mdomlistdat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

if ( $privoxymodB eq 0 && $privoxyver eq 0 ){
#malcode version
if ($copfiltersettings{'COMPLETE_RULES10'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/Malc0de.script.action" ){ 
$mcodedat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep Malc0de.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mcodedat = &Header::cleanhtml($mcodedat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}} 

#openbl version
if ($copfiltersettings{'COMPLETE_RULES12'} eq 'on' ){
if ( -e "/var/log/copfilter/default/opt/privoxy/etc/openBL.script.action" ){ 
$mopbldat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/privoxy/etc/ |grep openBL.script.action | sed 's/  */ /g' | cut -d " " -f 6-7`;
$mopbldat = &Header::cleanhtml($mopbldat,"y"); 
$malware = "$Lang::tr{'copfilter privoxy rules_info3'}:";
}}} 





if ( $banner ne '' ) {
print <<END
<tr>
<td colspan='5' valign='top'>
END
;
}


if ( ! $banner eq '' ){
print "<b>$banner</b>";
print "<br>";
	if ( ! $fandat eq ''){
		print "<br>$fandat $Lang::tr{'copfilter privoxy completes rules'}";
	}
	if ( ! $adbdat eq ''){
		print "<br>$adbdat $Lang::tr{'copfilter privoxy completes rules1'}";
	}
	if ( ! $plowdat eq ''){
		print "<br>$plowdat $Lang::tr{'copfilter privoxy completes rules3'}";
	}
	if ( ! $elistdat eq ''){
		print "<br>$elistdat $Lang::tr{'copfilter privoxy completes rules6'}";
	}
	if ( ! $eprivdat eq ''){
		print "<br>$eprivdat $Lang::tr{'copfilter privoxy completes rules7'}";
	}
	if ( ! $egerdat eq ''){
		print "<br>$egerdat $Lang::tr{'copfilter privoxy completes rules8'}";
	}
	if ( ! $efrdat eq ''){
		print "<br>$efrdat $Lang::tr{'copfilter privoxy completes rules9'}";
	}

	if ( ! $eitdat eq ''){
		print "<br>$eitdat $Lang::tr{'copfilter privoxy completes rules11'}";
	}
	if ( ! $adverdat eq ''){
		print "<br>$adverdat $Lang::tr{'copfilter privoxy completes rules13'}";
	}
	if ( ! $antisodat eq ''){
		print "<br>$antisodat $Lang::tr{'copfilter privoxy completes rules14'}";
	}



if ( $malware eq '' ){
print <<END
</td>
</tr>
END
;
}
}

if ( $malware ne '' ){
if ( $banner ne '' ){
print <<END
</td>
<td colspan='5' valign='top'>
END
;}
else {
print <<END
<tr>
<td colspan='5' valign='top'>
END
;}

print "<b>$malware</b>";
print "<br>";
	if ( ! $mdomdat eq ''){
		print "<br>$mdomdat $Lang::tr{'copfilter privoxy completes rules2'}";
	}
	if ( ! $hphdat eq ''){
		print "<br>$hphdat $Lang::tr{'copfilter privoxy completes rules4'}";
	}
	if ( ! $mdomlistdat eq ''){
		print "<br>$mdomlistdat $Lang::tr{'copfilter privoxy completes rules5'}";
	}
	if ( ! $mcodedat eq ''){
		print "<br>$mcodedat $Lang::tr{'copfilter privoxy completes rules10'}";
	}

	if ( ! $mopbldat eq ''){
		print "<br>$mopbldat $Lang::tr{'copfilter privoxy completes rules12'}";
	}


print <<END
</td>
</tr>
END
;
}



##############################################
if ( $copfiltersettings{'RULES_DISPLAY'} eq 'on' ) {



    if ($copfiltersettings{'BASIC_RULES'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
<tr>
	<td colspan='2'> <b>$Lang::tr{'copfilter privoxy basic rules'}</b></td>
	<td> <select name='BASIC_RULES' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'BASIC_RULES'}{'on'}>on</option>
		<option value='off' $selected{'BASIC_RULES'}{'off'}>off</option> </select></td>
		
</tr>
<tr>
	<td></td>
</tr>


<tr>
	<td colspan='5'><font size='2.7em'> $Lang::tr{'copfilter privoxy rules_info2'}</td>
	<td colspan='5'><font size='2.7em'> $Lang::tr{'copfilter privoxy rules_info3'}</td>

<tr>
	<td></td>
</tr>
END
;
    if ($copfiltersettings{'COMPLETE_RULES'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
				<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules'}</td>
				<td> <select name='COMPLETE_RULES' style="border:2px solid $OPTCOL;">
					<option value='on' $selected{'COMPLETE_RULES'}{'on'}>on</option>
					<option value='off' $selected{'COMPLETE_RULES'}{'off'}>off</option> </select> </td>
				<td colspan='2'></td>
END
;

    if ($copfiltersettings{'COMPLETE_RULES2'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
 
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules2'}</td>
	<td> <select name='COMPLETE_RULES2' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES2'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES2'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>


</tr>
END
;


    if ($copfiltersettings{'COMPLETE_RULES1'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }
print <<END
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules1'}</td>
	<td> <select name='COMPLETE_RULES1' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES1'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES1'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>

END
;


    if ($copfiltersettings{'COMPLETE_RULES4'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules4'}</td>
	<td> <select name='COMPLETE_RULES4' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES4'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES4'}{'off'}>off</option> </select></td>
		<td colspan='2'> </td>

</tr>
END
;

    if ($copfiltersettings{'COMPLETE_RULES3'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules3'}</td>
	<td> <select name='COMPLETE_RULES3' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES3'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES3'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>
END
;

    if ($copfiltersettings{'COMPLETE_RULES5'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules5'}</td>
	<td> <select name='COMPLETE_RULES5' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES5'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES5'}{'off'}>off</option> </select></td>
		<td colspan='2'> </td>

</tr>
END
;

if ( $privoxyver eq 0 ) {

if ( $privoxymodB eq 0) {


    if ($copfiltersettings{'COMPLETE_RULES6'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules6'}</td>
	<td> <select name='COMPLETE_RULES6' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES6'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES6'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>

END
;
    if ($copfiltersettings{'COMPLETE_RULES10'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }


print <<END

	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules10'}</td>
	<td> <select name='COMPLETE_RULES10' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES10'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES10'}{'off'}>off</option> </select></td>
		<td colspan='2'></td>

</tr>
END
;



    if ($copfiltersettings{'COMPLETE_RULES7'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules7'}</td>
	<td> <select name='COMPLETE_RULES7' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES7'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES7'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>


END
;




    if ($copfiltersettings{'COMPLETE_RULES12'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       

	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules12'}</td>
	<td> <select name='COMPLETE_RULES12' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES12'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES12'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>
</tr>


END
;


    if ($copfiltersettings{'COMPLETE_RULES8'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules8'}</td>
	<td> <select name='COMPLETE_RULES8' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES8'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES8'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>
</tr>


END
;


    if ($copfiltersettings{'COMPLETE_RULES9'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules9'}</td>
	<td> <select name='COMPLETE_RULES9' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES9'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES9'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>
</tr>


END
;


    if ($copfiltersettings{'COMPLETE_RULES11'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td colspan='2'> $Lang::tr{'copfilter privoxy completes rules11'}</td>
	<td> <select name='COMPLETE_RULES11' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES11'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES11'}{'off'}>off</option> </select> </td>
		<td colspan='2'></td>
</tr>


END
;


if ( $privoxymodC eq 0) {


    if ($copfiltersettings{'COMPLETE_RULES13'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules13'}</td>
	<td nowrap> <select name='COMPLETE_RULES13' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES13'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES13'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>
END
;
    if ($copfiltersettings{'COMPLETE_RULES14'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }



print <<END
			       
<tr>
	<td nowrap colspan='2'> $Lang::tr{'copfilter privoxy completes rules14'}</td>
	<td nowrap> <select name='COMPLETE_RULES14' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'COMPLETE_RULES14'}{'on'}>on</option>
		<option value='off' $selected{'COMPLETE_RULES14'}{'off'}>off</option> </select> </td>
				<td nowrap colspan='2'></td>
</tr>
END
;

}
}



    if ($copfiltersettings{'PRIVOXY_MAIL_NOTIF'} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
<tr>
	<td nowrap> &nbsp;</td>
</tr>

       <td nowrap colspan='2'>$Lang::tr{'copfilter upd_mail_notif'}&nbsp; </td>
       <td nowrap><select name='PRIVOXY_MAIL_NOTIF' style="border:2px solid $OPTCOL;">
            <option value='on' $selected{'PRIVOXY_MAIL_NOTIF'}{'on'}>on</option>
	     <option value='off' $selected{'PRIVOXY_MAIL_NOTIF'}{'off'}>off</option></select></td>            
       <td nowrap> </td>
       <td nowrap> </td>

END
;

print <<END
<tr>
	<td nowrap> &nbsp;</td>
</tr>

</font>
<tr>
  
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter privoxy automatic update'}:</b></td>       
        <td nowrap colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
</td>
        <td nowrap valign='top'><input type='radio' name='PRIVOXY_UPDATE_METHOD' value='periodically' $selected{'PRIVOXY_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='PRIVOXY_UPDATE_METHOD' value='manually' $selected{'PRIVOXY_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td nowrap valign='top'><input type='text' name='PRIVOXY_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'PRIVOXY_UPDATE_VALUE'}' />
        <select name='PRIVOXY_UPDATE_PERIOD'>
                <option value='hourly' $selected{'PRIVOXY_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'PRIVOXY_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'PRIVOXY_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'PRIVOXY_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>

       <td nowrap valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter privoxy update now'}' />

END
;
	if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_privoxy.done" ){				
  		print "<font color='#339933'>DONE</font>";
   		system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_privoxy.done");
	}


print <<END

<tr>

	<td nowrap colspan='5'>$Lang::tr{'copfilter privoxy update info'}</td>

</tr>

END
;
######### zum naechsten Privoxy Update ################
if ( -e "${copfilter_swroot}/etc/privoxy_counter" && $copfiltersettings{'PRIVOXY_UPDATE_METHOD'} eq 'periodically' ){
	my $nextupd = '';
	my $nexttime = 0;
	my $nextday = 0;
	my $nexthour = 0;
	my $nextminute = 0;
	$nexttime = `cat /var/log/copfilter/default/etc/privoxy_counter` + 5;

	$nextday = ($nexttime - $nexttime % 1440) / 1440;
	$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
	$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

	if ($nextday > 0){
		if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
	$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'privoxy_update'} </b>";
	}elsif($nexthour > 0){
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
		$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'privoxy_update'} </b>";
	}else{
		$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'privoxy_update'} </b>";}


print <<END

       <td nowrap colspan='2'><b>$nextupd</b></td>       
 

END
;
}

print <<END
<tr>
	<td nowrap></td>
</tr>
END
;


}
}




if ( $privoxymodD eq 0) {


print <<END






<table width='100%' border='0' cellpadding='5'>
<tr>
	<td>&nbsp;</td>
</tr>


<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='20%'></td>
	<td nowrap width='69%'></td>
</tr>

    <td nowrap><font size='2.7em'><b>DNS Filtering Status:</b></td>
    $statusdns
</tr>
<tr>
	<td nowrap></td>
</tr>
</table>
<table>
<td>  $Lang::tr{'copfilter DNS filtering_info1'}</td>
</table>

END
;


    if ($copfiltersettings{'DNS_FILTERING'} !~ /^default$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }




print <<END

<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='10%'></td>
	<td nowrap width='7%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='19%'></td>
</tr>




<tr>
</tr>



	
        <td nowrap > $Lang::tr{'copfilter DNS filtering'} </td>
	<td nowrap> &nbsp;</td>
	
	<td nowrap colspan='3'><select name='DNS_FILTERING' style="border:2px solid $OPTCOL;">
		<option value='Comodo SecureDNS' $selected{'DNS_FILTERING'}{'Comodo SecureDNS'}>Comodo SecureDNS</option>
		<option value='Norton ConnectSafe 1' $selected{'DNS_FILTERING'}{'Norton ConnectSafe 1'}>Norton ConnectSafe 1</option>
		<option value='Norton ConnectSafe 2' $selected{'DNS_FILTERING'}{'Norton ConnectSafe 2'}>Norton ConnectSafe 2</option>
		<option value='OpenDNS' $selected{'DNS_FILTERING'}{'OpenDNS'}>OpenDNS</option>
		<option value='default' $selected{'DNS_FILTERING'}{'default'}>default</option> </select></td>
		
</tr>

<tr>
	<td nowrap></td>
</tr>

</table>
<table>
<tr>
<td> $Lang::tr{'copfilter DNS warning'} </td>
</tr>
<tr>
 <td> 1.$Lang::tr{'copfilter DNS SecureDNS'} </td>
</tr>
<tr>
 <td> 2.$Lang::tr{'copfilter DNS Norton1'}</td>
</tr>
<tr>
 <td> 3.$Lang::tr{'copfilter DNS Norton2'}</td>
</tr>
<tr>
 <td> 4.$Lang::tr{'copfilter DNS Opendns'}</td>
</tr>
<tr>
	<td nowrap></td>
</tr>
<td> $Lang::tr{'copfilter DNS filtering_info2'}  </td>

<tr>
	<td nowrap> &nbsp;</td>
</tr>


</table>
<table>

END
;
}









if ( $copfiltersettings{'ICAP_URLFILTER'} !~/^off$/) {
     $OPTCOL='#009C28'; }
else {
     $OPTCOL='#C1C1C1'; }



print <<END


<tr>
	<td>&nbsp;</td>
</tr>


<tr><td height='10'></tr>


<tr>
        <td colspan='2'> $Lang::tr{'copfilter c-icap_urlfilter'}</td>
        <td> <select name='ICAP_URLFILTER' style="border:2px solid $OPTCOL;"> 
             <option value='on' $selected{'ICAP_URLFILTER'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_URLFILTER'}{'off'}>off</option> </select></td>
	<td height='45'></td>
</tr>
<tr>
    <td nowrap>$Lang::tr{'copfilter c-icap restart'}</td>
</tr>
</table>
<table>
<tr>
        <td colspan='3'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        </td>
</tr>

<tr>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td width='40'>&nbsp; </td>
        <!-- <td> $Lang::tr{'copfilter http4'}</td> -->
        <td> </td>
</tr>



END
;
&Header::closebox();



print "<br />\n";
print "</form>";

if ( $copfiltersettings{'ICAP_URLFILTER'} eq 'on' ) {
    &Header::openbox('100%', 'left', 'URL-Filter settings');
    print "<form method='post' action='/cgi-bin/copfilter_c-icap.cgi' enctype='multipart/form-data'>";



$status = `ls $BASEDIR/opt/c_icap/var/run | grep 'copfilter_c-icap-dbmaker.pid'`;
if ( $status ) {
    print "<table width='100%'><td class='base' align='center'><hr style='color:black; background: black; height:2px; width:60%;'>";
    print "<br /><font color='#D61010'><b>The C-ICAP URL-Filter DBmaker is still running! Please do not restart or reload C-ICAP!</b></font><br /><br />";
    print "<hr style='color:black; background: black; height:2px; width:60%;'></td></table>";
}

	if ( $copfiltersettings{'ICAP_DENY_DOMAINS'} !~/^off$/) {
	     $OPTCOL='#009C28'; }
	else {
	     $OPTCOL='#C1C1C1'; }

print <<END
<table border='0' cellpadding='5'>
<tr>
	<td width='240'></td>
	<td width='60'></td>
	<td width='240'></td>
	<td width='1'></td>
	<td width='60'></td>
	<td>&nbsp;</td>
</tr>
<tr>
        <td> $Lang::tr{'copfilter c-icap_own_domainlist'}
             $Lang::tr{'copfilter c-icap_own_domainlist_notice'}</td>
        <td> <select name='ICAP_DENY_DOMAINS' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_DENY_DOMAINS'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_DENY_DOMAINS'}{'off'}>off</option> </select></td>
END
;
	if ( $copfiltersettings{'ICAP_ALLOW_DOMAINS'} !~/^off$/) {
	     $OPTCOL='#009C28'; }
	else {
	     $OPTCOL='#C1C1C1'; }

print <<END
        <td> $Lang::tr{'copfilter c-icap_own_domainlistwhite'}
             $Lang::tr{'copfilter c-icap_own_domainlist_notice'}</td>
        <td> <select name='ICAP_ALLOW_DOMAINS' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_ALLOW_DOMAINS'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_ALLOW_DOMAINS'}{'off'}>off</option> </select></td>
        <td>\n</td>

END
;
	if ( $copfiltersettings{'ICAP_DNSBL'} !~/^off$/) {
	     $OPTCOL='#009C28'; }
	else {
	     $OPTCOL='#C1C1C1'; }

print <<END

        <td> $Lang::tr{'copfilter c-icap_dnsbl_check'} </td>
        <td> <select name='ICAP_DNSBL' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_DNSBL'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_DNSBL'}{'off'}>off</option> </select></td>
        <td>\n</td>
</tr>
<tr>
</tr>
</table>
<table>
<tr>
	<td width='290'></td>
	<td width='30'></td>
	<td width='175' align='top'></td>
	<td width='195' align='top'></td>
<!---	<td width='220' align='top'></td> --->
	<td>&nbsp;</td>
</tr>
<tr>
        <td colspan='2'><textarea name='ICAP_BLACK_DOMAINS' cols='35' rows='8' />
END
;
        print $copfiltersettings{'ICAP_BLACK_DOMAINS'};
print <<END
</textarea></td>
        <td colspan='2'><textarea name='ICAP_WHITE_DOMAINS' cols='35' rows='8' />
END
;
        print $copfiltersettings{'ICAP_WHITE_DOMAINS'};
print <<END
</textarea></td>
        <td><u>$Lang::tr{'copfilter c-icap_dnsbl_sources'}: </u><br /><i> multi.surbl.org<br /> dnsbl.proxybl.org<br /> http.dnsbl.sorbs.net<br /> socks.dnsbl.sorbs.net<br /><br /><br /><br /><br /><br /></i></td>
        <td>\n</td>
</table>

<!--- URL-Filter exceptions --->

<table border='0' cellpadding='5'>
 <tr>
	<td width='240'></td>
	<td width='140'></td>
<!---	<td width='245'></td>
	<td width='1'></td>
	<td width='70'></td>
	<td>&nbsp;</td> --->
</tr>
END
;

	if ( $copfiltersettings{'ICAP_URL_EXCEPT'} !~/^off$/) {
	     $OPTCOL='#009C28'; }
	else {
	     $OPTCOL='#C1C1C1'; }

print <<END

<tr>
        <td width='240'>$Lang::tr{'copfilter c-icap_url_exceptions_src'}</td>
        <td> <select name='ICAP_URL_EXCEPT' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_URL_EXCEPT'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_URL_EXCEPT'}{'off'}>off</option> </select></td>
</tr>
<tr>
        <td colspan='2'><textarea name='ICAP_URL_EXCT' cols='35' rows='8' />
END
;
        print $copfiltersettings{'ICAP_URL_EXCT'};
print <<END
</textarea></td>
</tr>
</table>
<table>
<tr>
    <td>&nbsp;</td>
</tr>
<tr>

	<br /><br /><br />
</tr>
<tr>
        <hr style="color:black; background: black; height:2px; width:97%;">
    <td colspan='2'><b>$Lang::tr{'copfilter c-icap_upload_blacklist_notice'}:</b></td>
</tr>
<tr>
    <td> <input type="file" size='40' name="BL" /> &nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter c-icap_upload_blacklist'}' /></td>
    <br />
</tr>
</table>
<table>
<tr>
	<td height='20'> &nbsp;</td>
	<br /><br />
</tr>

END
;

	if ( $copfiltersettings{'ICAP_BLACKLIST'} !~/^off$/) {
	     $OPTCOL='#009C28'; }
	else {
	     $OPTCOL='#C1C1C1'; }

print <<END
<tr>
        <hr style="color:black; background: black; height:2px; width:97%;">
        <td>$Lang::tr{'copfilter c-icap_use_blacklist'}</td>
        <td> <select name='ICAP_BLACKLIST' style="border:2px solid $OPTCOL;">
             <option value='on' $selected{'ICAP_BLACKLIST'}{'on'}>on</option>
             <option value='off' $selected{'ICAP_BLACKLIST'}{'off'}>off</option> </select></td>
	<td>\n</td>
	<td>\n</td>
</table>
END
;
# Generate the Blacklist menu
my $z = 0;
my $b = 0;

my $COUNT=int((@COUNT)/4+1);
my $q;
my $SOURCE;
if ($copfiltersettings{'ICAP_LIST_SOURCE'} =~ /^shalla_blacklist$/) {
    $SOURCE = "Shalla\'s Blacklist";
}
if ($copfiltersettings{'ICAP_LIST_SOURCE'} =~ /^url_blacklist_big$/) {
    $SOURCE = "URL Big Blacklist.com";
}
if ($copfiltersettings{'ICAP_LIST_SOURCE'} =~ /^url_blacklist_small$/) {
    $SOURCE = "URL Small Blacklist.com";
}
if ($copfiltersettings{'ICAP_LIST_SOURCE'} =~ /^university_toulouse$/) {
    $SOURCE = "University of Toulouse Blacklist";
}
if ($copfiltersettings{'ICAP_LIST_SOURCE'} =~ /^mesd$/) {
    $SOURCE = "MESD-Blacklist";
}
if ($copfiltersettings{'ICAP_LIST_SOURCE'} =~ /^manual_upload$/) {
    $SOURCE = "Uploaded Blacklist";
}
my $LASTUPDATE=`ls -la /var/log/copfilter/default/opt/c_icap/etc/blacklists | awk '{ print "$Lang::tr{'copfilter c-icap_blacklist_last_update'}: &nbsp; &nbsp; &nbsp; </b></td><td><b>"\$7". "\$6" "\$8 }' | tail -n1`;
print <<END
<table>
<tr><td height='10'></td></tr>
<tr><td><b>$Lang::tr{'copfilter c-icap_blacklist_in_use'}: &nbsp; &nbsp; &nbsp; </b></td><td><b> $SOURCE </b></td></tr>
<tr><td><b>$LASTUPDATE<br /></b></td></tr>
<tr><td height='10'></td></tr>
</table>
<table>
END
;
for ($b = 0; $b<=$COUNT; $b++) {
    $z++;
    #$BLACK[$z] =~ s/\s//g;
print "<tr>";
    if ($BLACK[$z]) {
    $q=$BLACK[$z];

    if ($copfiltersettings{$q} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
        <td> $BLACKNAME[$z]</td>
        <td> <select name=$q style="border:2px solid $OPTCOL;">
        <option value='on' $selected{$q}{'on'}>on</option>
        <option value='off' $selected{$q}{'off'}>off</option> </select></td>
    <td width='80'></td>
END
;
    }
    $z++;
    if ($BLACK[$z]) {
    $q=$BLACK[$z];

    if ($copfiltersettings{$q} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
        <td> $BLACKNAME[$z] </td>
        <td> <select name=$q style="border:2px solid $OPTCOL;">
        <option value='on' $selected{$q}{'on'}>on</option>
        <option value='off' $selected{$q}{'off'}>off</option> </select></td>
    <td width='80'></td>
END
;
    }
    $z++;
    if ($BLACK[$z]) {
    $q=$BLACK[$z];

    if ($copfiltersettings{$q} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
        <td> $BLACKNAME[$z] </td>
        <td> <select name=$q style="border:2px solid $OPTCOL;">
        <option value='on' $selected{$q}{'on'}>on</option>
        <option value='off' $selected{$q}{'off'}>off</option> </select></td>
    <td width='80'></td>
END
;
    }
    $z++;
    if ($BLACK[$z]) {
    $q=$BLACK[$z];

    if ($copfiltersettings{$q} !~ /^off$/) {
        $OPTCOL='#009C28'; }
    else {
        $OPTCOL='#C1C1C1'; }

print <<END
        <td> $BLACKNAME[$z] </td>
        <td> <select name=$q style="border:2px solid $OPTCOL;">
        <option value='on' $selected{$q}{'on'}>on</option>
        <option value='off' $selected{$q}{'off'}>off</option> </select></td>
    <td width='80'></td>
END
;
    }
    print "</tr>";
}

print <<END
</table>
<table>
<tr>
	<td> &nbsp;</td>
</tr>
</table>
<table>
<tr>
	<td height='10'> &nbsp;</td>
</tr>
</table>
<table>
<tr>
        <td><b>$Lang::tr{'copfilter c-icap_update_blacklist_interval'}:</b><br /><br /></td>
</tr>
<tr>
        <hr style="color:black; background: black; height:2px; width:97%;">
        <br /><br />
        <td valign='top'>
        <input type='radio' name='ICAP_UPDATE_METHOD' value='periodically' $selected{'ICAP_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='ICAP_UPDATE_METHOD' value='manually'     $selected{'ICAP_UPDATE_METHOD'}{'manually'}     />$Lang::tr{'copfilter disabled'}</td>
        <td valign='top'><input type='text' name='ICAP_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'ICAP_UPDATE_VALUE'}' />
        <select name='ICAP_UPDATE_PERIOD'>
                <option value='daily' $selected{'ICAP_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'ICAP_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'ICAP_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select></td>
</tr>
<tr>
        <td>Time selection: </td>
                <td>Hours: 
                <select name='ICAP_HOURS'>


END
;
                for(my $e = 0; $e <= 23; $e++)
                {
                   my $ee = sprintf("%02d", $e);
                   print "<option value='$ee' $selected{'ICAP_HOURS'}{$ee}>$ee</option>";
                }
print <<END
                </select>

                Minutes: 
                <select name='ICAP_MINUTES'>
END
;
                for(my $v = 0; $v <= 55; $v = $v + 5)
                {
                   my $vv = sprintf("%02d", $v);
                   print "<option value='$vv' $selected{'ICAP_MINUTES'}{$vv}>$vv</option>";
                }
print <<END
                </select></td>
</tr>
</table>
<table>
<tr>
        <td><b>$Lang::tr{'copfilter c-icap_blacklist_download_source'}:</b></td>
</tr>
<tr>
        <td>
        <select name='ICAP_LIST_SOURCE'>
                <option value='shalla_blacklist' $selected{'ICAP_LIST_SOURCE'}{'shalla_blacklist'}>Shalla\'s Blacklist (private)</option>
                <option value='url_blacklist_big' $selected{'ICAP_LIST_SOURCE'}{'url_blacklist_big'}>URL big Blacklist.com (costs)</option>
                <option value='url_blacklist_small' $selected{'ICAP_LIST_SOURCE'}{'url_blacklist_small'}>URL small Blacklist.com (test)</option>
                <option value='university_toulouse' $selected{'ICAP_LIST_SOURCE'}{'university_toulouse'}>University of Toulouse list (free)</option>
                <option value='mesd' $selected{'ICAP_LIST_SOURCE'}{'mesd'}>MESD Blacklists (free)</option>
                <option value='manual_upload' $selected{'ICAP_LIST_SOURCE'}{'manual_upload'}>Uploaded Blacklist</option>
        </select></td>
        <td valign='top' align='left'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter c-icap_update_blacklist_now'}' /> </td>
        <br />
<br/>
</tr>


<tr>
	<td width='240'></td>
	<td width='100'></td>
	<td width='50'></td>
	<td width='250'></td>
	<td>&nbsp;</td>
</tr>


END
;

	if ( $copfiltersettings{'ICAP_SENDMAIL'} !~/^off$/) {
	     $OPTCOL='#009C28'; }
	else {
	     $OPTCOL='#C1C1C1'; }

print <<END

<td> <br> 
	<b>$Lang::tr{'copfilter c-icap_template_settings'}:</b>
	<br> $Lang::tr{'copfilter c-icap_mail'}</td>
	<td> <br> <br><select name='ICAP_SENDMAIL' style="border:2px solid $OPTCOL;">
		<option value='on' $selected{'ICAP_SENDMAIL'}{'on'}>on</option>
		<option value='off' $selected{'ICAP_SENDMAIL'}{'off'}>off</option> </select> </td>
</td>

</tr>




</table>
<table>

<tr><br /><br />
        <hr style="color:black; background: black; height:2px; width:97%;"> 
</tr>

<tr>
        <td colspan='3'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        </td>
</tr>

<tr>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td width='40'>&nbsp; </td>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter c-icap_reload'}' /> </td>
        <td width='40'>&nbsp; </td>
</tr>
</table>
END
;
print "</form>";
&Header::closebox();
}


&Header::openbox('100%', 'left', 'Description');
print "<form method='post' action='/cgi-bin/copfilter_c-icap.cgi' enctype='multipart/form-data'>";
print <<END
<table border='0' cellpadding='5'>
<tr>
    <td valign='top' colspan='4'> $Lang::tr{'copfilter c-icap1'} </td>
</tr>
<tr>
	<td> &nbsp;</td>
</tr>

<tr>
    <td colspan='5'> $Lang::tr{'copfilter c-icap note'} </td>
</tr>

<tr>
    <td colspan='5'> $Lang::tr{'copfilter c-icap note2'} </td>
</tr>

<tr>
    <td colspan='5'> 
        $Lang::tr{'copfilter c-icap restart'} <br />
    </td>
	<td width='50%' nowrap valign='bottom' align='right'><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>

</tr>

</table>


END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
